% Joe Jupin
% Homework 3 Part 1
% Smoothing Filter

% clear all variables
clear all;

% read image
Im8 = imread('noise_2.gif');
% convert to double
ImD = double(Im8);
% set image output to gray
colormap(gray);
% show unprocessed image
imshow(Im8);

% neighborhood size
% must be an odd number
neigh = 3;
% padded boader size
bdr = (neigh-1)/2;

% make smoothing convolution mask
w = (1/(neigh*neigh))*ones(neigh, neigh);

% for Gaussian noise
% neigh must be 3
%w = (1/10)*[1 1 1; 1 2 1; 1 1 1];
%w = (1/16)*[1 2 1; 2 4 2; 1 2 1];

% get size of image
[xsize ysize] = size(ImD);

% create zero padded image
ImP = zeros(xsize+2*bdr, ysize+2*bdr);
ImP(1+bdr:xsize+bdr, 1+bdr:ysize+bdr) = ImD;

% perform smoothing filter
for i=1:xsize
    for j=1:ysize
        x = ImP(i:i+2*bdr, j:j+2*bdr);
        ImD(i, j) = 0;
        for k=1:neigh*neigh
            ImD(i, j) = ImD(i, j) + (x(k)*w(k));
        end
    end
end

% convert to image
Im8 = uint8(ImD);
% display image
figure, imshow(Im8);